<id>
Extra Message Fields SP1.3.1
</id>

<version>
1
</version>

<mod info>
This mod gives you complete control over the contents of the post-page for each board, including enhanced subject options and preformatted headers in your messages.


Features Include: 
    Enhanced Subject Options
      - The addition of one drop-down list box with as many enhanced subject options as you want.
      - The option of none, simple or custom formatting of the subject.
    Extra Message Fields
      - The addition of one drop-down list box with as many options as you want.
      - The addition of as many single line text fields as you want.
      - The option of none, simple, advanced or custom message displays.
      - The option to have the extra fields on all threads, or just the first thread.
      - The option to hide empty fields.


To Install:
 - Apply this Mod file (using BoardMod or manually by following the instructions)
 - Upload the modified files
 - Copy the ExtraMessages.pl file to your sources directory
 - Configure the new options via the Admin option


To Configure:
 - Go to the admin center and click on "Edit Extra Message Fields"
 - Use the drop-down list at the top to select which board you want to edit. (You can configure each board individually)
 - Enter a caption for the drop down lists (this will appear to the left of the drop-down list on the post page)
 - Enter the options you want to appear in the drop-down lists (one per line, seperated with a return)
 - Enter the captions you want to appear next to the extra text fields (one per line, seperated with a return - each entry will create a new text field)
 - Use the drop down lists to select none, simple, advanced or custom formatting.
 - If you select "custom", use the template boxes to format the extra fields and enhanced subject. Use the following tags to include the extra information:
	- [caption0] & [field0] = caption and value of the drop-down enhanced subject list
	- [caption1] & [field1] = caption and value of the drop-down message list
	- [caption2] & [field2], [caption3] & [field3], etc. = captions and values of the extra fields
	- [if0] ... [/if0], [if1] ... [/if1], [if2] ... [/if2], etc. = hide contents if field1, field2, etc. are empty (and the "hide empty fields" option is checked)
	- [header] = the advanced format drop-down header contents
	- [simple] = the simple format extra field captions and values (useful if you use the "hide empty fields" option)
	- [block] = the advanced format extra field captions and values (useful if you use the "hide empty fields" option)
	- UBBC tags can be used to format the Extra message fields
 - Use the checkboxes to configure the other functions and press the save button.
 - Repeat for any other boards you wish
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'usersrecentposts',"Profile.pl&usersrecentposts");
</search for>

<add before>
'extramessage',"ExtraMessage.pl&ExtraMessage", 
'extramessage2',"ExtraMessage.pl&ExtraMessage2",
</add before>

<edit file>
english.lng
</edit file>

<search for>
$txt{'18'} = "Index";
</search for>

<add before>
$txt{'19a'} = "Edit Extra Message Fields";
</add before>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=editnews">$txt{'7'}</a><br>
</search for>

<add before>
        - <a href="$cgi;action=extramessage">$txt{'19a'}</a><br>
</add before>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
		unlink("$boardsdir/$curboard.ttl");
</search for>

<add after>
		unlink("$boardsdir/$curboard.xtra");
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
			unlink("$boardsdir/$curboard.ttl");
</search for>

<add after>
			unlink("$boardsdir/$curboard.xtra");
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
sub Postpage {
</search for>

<add after>
## [Extra Message Fields] ##
	if (-e("$boardsdir/$currentboard.xtra")) {require "$boardsdir/$currentboard.xtra";}

	$subjectxtra = "";
	$messagextra = "";
	if ($action eq 'post' || $action eq 'post2') {
		if ($xtraformats ne '0' && $xtraopts ne "" && $threadid eq '') {
			@xoptions = split(/\|/, $xtraopts);
			$subjectxtra .= qq~<tr>\n~;
			$subjectxtra .= qq~        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$xtraheadings:</b></font></td>\n~;
			$subjectxtra .= qq~        <td class="windowbg" bgcolor="$color{'windowbg'}"><select name="field0" size="1">\n~;
			$i = 0;
			foreach $xtmp (@xoptions) {
				if ($field[0] eq $xtmp) {$selected=" selected";} else {$selected = "";}
				$subjectxtra .= qq~<option value="$i"$selected>$xtmp</option>~;
				$i++;
			}
			$subjectxtra .= qq~</td>\n      </tr>\n~;
		}

		if ($xtraformat ne '0' && $xtraopt ne "" && ($xtrareply eq "1" || ($xtrareply eq "0" && $threadid eq ''))) {
			@xoptions = split(/\|/, $xtraopt);
			$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$xtraheading:</b></font></td>\n~;
			$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="field1" size="1">~;
			$i = 0;
			foreach $xtmp (@xoptions) {
				if ($field[1] eq $xtmp) {$selected=" selected";} else {$selected = "";}
				$messagextra .= qq~<option value="$i"$selected>$xtmp</option>~;
				$i++;
			}
			$messagextra .= qq~</td>\n      </tr><tr>\n~;
		}
		if ($xtraformat ne '0' && $xtrafield ne "" && ($xtrareply eq "1" || ($xtrareply eq "0" && $threadid eq ''))) {
			@xfields = split(/\|/, $xtrafield);
			$i = 2;
			foreach $xtmp (@xfields) {
				$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$xtmp:</b></font></td>\n~;
				$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><input type="text" name="field$i" value="$field[$i]" size="60" maxlength="60"></font></td>\n~;
				$messagextra .= qq~      </tr><tr>\n~;
				$i++;
			}
		}
	}
## [/Extra Message Fields] ##

</add after>

<search for>
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'70'}:</b></font></td>
</search for>

<add before>
$subjectxtra
</add before>

#### If you have Add-More-Smilies 2 installed, remove the "</td>" from the following line ####

<search for>
        <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'72'}:</b></font></td>
</search for>

<add before>
$messagextra
</add before>

<search for>
	if (length($sub) > 50) { $sub = substr($sub,0,50); }
</search for>

<replace>
	($xmessage, $xsubject) = &format_extra;
	$message = $xmessage.$message;
	$csubject = $xsubject.$sub;
	if (length($csubject) > 50) { $csubject = substr($csubject,0,50); }
	&ToHTML($csubject);
</replace>

<search for>
	$csubject = $sub;
	&LoadCensorList;	# Load Censor List
</search for>

<replace>
	&LoadCensorList;	# Load Censor List
</replace>

<search for>
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
	&fatal_error($txt{'78'}) unless($message);
</search for>

<add before>
	($xmessage, $xsubject) = &format_extra;
	$message = $xmessage.$message;
	$subject = $xsubject.$subject;
</add before>

<search for>
1;
</search for>

<add before>

sub format_extra{
	my $threadid = $FORM{'threadid'} || '';
	my ($xmessage, $xheader, $xblock, $xsimple, $xsubject) = "";

	if (-e("$boardsdir/$currentboard.xtra")) {
		require "$boardsdir/$currentboard.xtra";
		@xoptions = split(/\|/, $xtraopts);
		$caption[0] = $xtraheadings; $field[0] = $xoptions[$FORM{"field0"}];
		@xoptions = split(/\|/, $xtraopt);
		$caption[1] = $xtraheading; $field[1] = $xoptions[$FORM{"field1"}];
		@xfields = split(/\|/, $xtrafield);
		$count = 1;
		if ($xtrafield ne "") {
			foreach $xtmp (@xfields) {
				$count++;
				$caption[$count] = $xtmp; $field[$count] = $FORM{"field$count"};
			}
		}
		for( $i = 0; $i <= $count; $i++ ) {
			&FromHTML($caption[$i]);
			$caption[$i] =~ s/&#36;/\$/g;
			$caption[$i] =~ s/&#64;/\@/g;
		}
		&FromHTML($field[0]); $field[0] =~ s/&#36;/\$/g; $field[0] =~ s/&#64;/\@/g;
		&FromHTML($field[1]); $field[1] =~ s/&#36;/\$/g; $field[1] =~ s/&#64;/\@/g;
	}

	if ($xtraformat ne '0' && ($xtrareply eq '1' || ($xtrareply eq '0' && $threadid eq ''))) {

		# define [header], [block] and [simple]
		if ($xtraopt ne "") {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[1] ne "") {
				if ($xtraformat eq "1") {$xheader .= qq~$caption[1]: $field[1]\n~;} else {$xheader .= qq~\[center\] \[b\]\[size=3\] $field[1] \[\/size\]\[\/b\] \[\/center\]~;} 
			}
		}
		if ($xtrafield ne "") {
			for( $i = 2; $i <= $count; $i++ ) {
				if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
					$xblock .= qq~\[tr\]\[td\]\[size=2\] $caption[$i]: \[\/size\]\[\/td\]\[td\]\[b\]\[size=2\] $field[$i] \[\/size\]\[\/b\]\[\/td\]\[\/tr\]~;
					$xsimple .= qq~$caption[$i]: $field[$i]\n~;
				}
			}
			if ($xblock ne "") {$xblock = qq~\[table\] $xblock \[tr\]\[td\] \[\/td\]\[td\] \[\/td\]\[\/tr\] [\/table\]~;}
		}

		# define xmessage based on template
		if ($xtraformat eq "2") {$xmessage = qq~[header][block]~;} # Advanced format
		elsif ($xtraformat eq "3" && $xtratemplate ne "") { # Custom Format
			$xtratemplate =~ s/\|/\n/g;
			&FromHTML($xtratemplate);
			$xtratemplate =~ s/&#36;/\$/g;
			$xtratemplate =~ s/&#64;/\@/g;
			$xmessage = $xtratemplate;
		} else {$xmessage = qq~[header][simple]~;} # Simple format

		for( $i = 0; $i <= $count; $i++ ) {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
				$xmessage =~ s/\[caption$i\]/$caption[$i]/isg;
				$xmessage =~ s/\[field$i\]/$field[$i]/isg;
				$xmessage =~ s~\[if$i\](.*?)\[\/if$i\]~$1~isg;
			} else {
				$xmessage =~ s/\[caption$i\]//isg;
				$xmessage =~ s/\[field$i\]//isg;
				$xmessage =~ s~\[if$i\](.*?)\[\/if$i\]~~isg;
			}
		}	
		$xmessage =~ s/\[block\]/$xblock/isg;
		$xmessage =~ s/\[simple\]/$xsimple/isg;
		$xmessage =~ s/\[header\]/$xheader/isg;
		if ($xmessage ne "") {$xmessage .= qq~\n~;}
	}

	if ($xtraformats ne '0' && $threadid eq '') {

		# define xsubject based on template
		if ($xtraformats eq "2" && $xtratemplates ne "") { # Custom Format
			&FromHTML($xtratemplates);
			$xtratemplates =~ s/&#36;/\$/g;
			$xtratemplates =~ s/&#64;/\@/g;
			$xsubject = $xtratemplates;
		} else {$xsubject = qq~[field0][if0] [/if0]~;} # Simple format

		for( $i = 0; $i <= $count; $i++ ) {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
				$xsubject =~ s/\[caption$i\]/$caption[$i]/isg;
				$xsubject =~ s/\[field$i\]/$field[$i]/isg;
				$xsubject =~ s~\[if$i\](.*?)\[\/if$i\]~$1~isg;
			} else {
				$xsubject =~ s/\[caption$i\]//isg;
				$xsubject =~ s/\[field$i\]//isg;
				$xsubject =~ s~\[if$i\](.*?)\[\/if$i\]~~isg;
			}
		}	
	}
	return ($xmessage, $xsubject);
}

</add before>